--- src/backend/storage/buffer/buf_init.c.orig	2014-08-18 14:10:36.933017070 -0400
+++ src/backend/storage/buffer/buf_init.c	2014-08-19 16:56:13.567196743 -0400
@@ -13,15 +13,122 @@
  *-------------------------------------------------------------------------
  */
 #include "postgres.h"
+#include <sys/types.h> 
+#include <unistd.h>
 
 #include "storage/bufmgr.h"
 #include "storage/buf_internals.h"
-
+#include <stdlib.h> /* for getenv() */
+#include <errno.h> /* for strtoul() */
+#if defined(USE_AIO_ATOMIC_BUILTIN_COMP_SWAP) && defined(USE_AIO_SIGEVENT)
+#include <sched.h>
+#endif /*  defined(USE_AIO_ATOMIC_BUILTIN_COMP_SWAP) && defined(USE_AIO_SIGEVENT)  */
 
 BufferDesc *BufferDescriptors;
 char	   *BufferBlocks;
-int32	   *PrivateRefCount;
+int32	   *PrivateRefCount;       /*  array of counts per buffer of how many times this task has pinned this buffer */
+
+volatile struct BAiocbAnchor *BAiocbAnchr = (struct BAiocbAnchor *)0;  /*  anchor for all control blocks pertaining to aio  */
+
+int CountInuseBAiocbs(void);     /*  keep compiler happy */
+void ReportFreeBAiocbs(void);    /*  keep compiler happy */
+
+extern int	MaxConnections;  /*  max number of client connections which postmaster will allow  */
+int numBufferAiocbs = 0;         /*  total number of  BufferAiocbs in pool (0 <=> no async io) */
+int hwmBufferAiocbs = 0;         /*  high water mark of in-use  BufferAiocbs in pool
+                                 **  (not required to be accurate, kindly maintained for us somehow by postmaster)
+                                 */
 
+#ifdef USE_PREFETCH
+unsigned int prefetch_dbOid = 0; /*  database oid of relations on which prefetching to be done - 0 means all */
+unsigned int prefetch_bitmap_scans = 1; /*  boolean whether to prefetch bitmap heap scans        */
+unsigned int prefetch_heap_scans = 0;   /*  boolean whether to prefetch non-bitmap heap scans    */
+unsigned int prefetch_sequential_index_scans = 0;  /*  boolean whether to prefetch sequential-access non-bitmap index scans  */
+unsigned int prefetch_index_scans = 256;  /*  boolean whether to prefetch non-bitmap index scans also numeric size of pfch_list  */
+unsigned int prefetch_btree_heaps = 1;  /*  boolean whether to prefetch heap pages in _bt_next for non-bitmap index scans   */
+#endif /* USE_PREFETCH */
+
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+int maxGetBAiocbTries = 1;       /*  max times we will try to get a free BufferAiocb */
+int maxRelBAiocbTries = 1;       /*  max times we will try to release a BufferAiocb back to freelist */
+
+/*  locking protocol for manipulating the BufferAiocbs and FreeBAiocbs list :
+**    1.    ownership of a BufferAiocb :
+**          to gain ownership of a BufferAiocb, a task must
+**          EITHER    remove it from FreeBAiocbs (it is now temporary owner and no other task can find it)
+**                    if decision is to attach it to a buffer descriptor header, then
+**                       .   lock the buffer descriptor header
+**                       .   check  NOT flags & BM_AIO_IN_PROGRESS
+**                       .   attach to buffer descriptor header
+**                       .   increment the BufferAiocb.dependent_count
+**                       .   unlock the buffer descriptor header
+**                     and ownership scope is from lock to unlock
+***          OR        locate it by dereferencing the pointer in a buffer descriptor,
+**                    in which case :
+**                       .   lock the buffer descriptor header
+**                       .   check  flags & BM_AIO_IN_PROGRESS
+**                       .   increment the BufferAiocb.dependent_count
+**                       .   if decision is to return to FreeBAiocbs,
+**                           then   (with buffer descriptor header still locked)
+**                                  .  turn off BM_AIO_IN_PROGRESS
+**                       .   IF        the BufferAiocb.dependent_count == 1 (I am sole dependent)
+**                       .   THEN
+**                       .       .  decrement the BufferAiocb.dependent_count
+**                               .  return to FreeBAiocbs (see below)
+**                       .   unlock the buffer descriptor header
+**                     and ownership scope is from lock to either return to FreeBAiocbs or unlock
+**    2.    adding and removing from FreeBAiocbs :
+**      two alternative methods - controlled by conditional macro definition LOCK_BAIOCB_FOR_GET_REL
+**       2.1 LOCK_BAIOCB_FOR_GET_REL is defined - use a lock
+**          .   lock BufFreelistLock exclusive
+**          .   add / remove from FreeBAiocbs
+**          .   unlock BufFreelistLock exclusive
+**          advantage of this method  -  never fails to add or remove
+**       2.2  LOCK_BAIOCB_FOR_GET_REL is not defined - use compare_and_swap
+**          .   retrieve the current Freelist pointer and validate
+**          .   compare_and_swap on/off the FreeBAiocb list
+**          .   unlock BufFreelistLock exclusive
+**          advantage of this method  -  never waits
+**          to avoid losing a FreeBAiocbs,   save it in a process-local cache and reuse
+*/
+#ifdef USE_AIO_SIGEVENT                                    /*    signal non-originator waiters instead of letting them poll */
+extern long num_startedaio;
+extern long num_signalledaio;
+
+/*  structures relating to keeping track of aios originated by this backend */
+/*  BAiocbIostatusArray is a circular array of aio operations past and present;
+ *  each item is a 32-bit unsigned int container consisting of two fields
+ *    .   unsigned short status - one of three states :
+ *        .   not_in_progress          no aio in progress,  io lock not held
+ *        .   locked_in_progress          aio in progress,  io lock held eXclusive
+ *        .   locked_pending_release      aio completion signalled,  io lock held eXclusive
+ *    .   unsigned short BAiocb_index - the array index of the associated BAiocb when io lock held
+ *
+ *  The active items in the array correspond to all aio_reads issued by this backend
+ *  since the earliest io-locked aio.    BAiocbIostatusEarliest indexes this entry.
+ *  Every aio operation originated by this backend is assigned a monotonic-increasing sequence number
+ *  which,   modulo the size of the array,  identifies the array item representing that aio.
+*/
+unsigned int volatile * BAiocbIostatusArray = (unsigned int *)0;
+unsigned long BAiocbNextaioOrdinal = 0;           /*  ordinal number of each aio in the sequence  */
+unsigned long BAiocbEarliestiolockedOrdinal = 0;  /*  ordinal number of earliest io-locked aio */
+unsigned long BAiocbIostatusDimension = 0;        /*  number of items in array */
+
+  /*  BufHandlSigAsync is invoked whenever io completion signal is issued.
+  *   siginfP->si_value.sival_ptr contains the address of the LWlock
+  *   on which non-originator waiters wait and which we are to release
+  */
+void BufHandlSigAsync(int sigsent, siginfo_t * siginfP, void *ucontext);
+sigset_t blockaiosighandlrmask;     /*  sig mask to block AIO signal temporarily */
+#endif /*  USE_AIO_SIGEVENT    */
+#else   /*  not USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+        /*   this dummy structure is to ensure that references to these fields in other bufmgr runtime code
+        **   that is not conditionally ifdefd on USE_AIO_ATOMIC_BUILTIN_COMP_SWAP compiles and runs correctly
+        */
+        struct BAiocbAnchor dummy_BAiocbAnchr = { (struct BufferAiocb*)0 , (struct BufferAiocb*)0 };
+int maxGetBAiocbTries = -1;       /*  max times we will try to get a free BufferAiocb */
+int maxRelBAiocbTries = -1;       /*  max times we will try to release a BufferAiocb back to freelist */
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
 
 /*
  * Data Structures:
@@ -73,7 +180,20 @@ void
 InitBufferPool(void)
 {
 	bool		foundBufs,
-				foundDescs;
+				foundDescs
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+              , foundAiocbs
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+          ;
+#if defined(USE_PREFETCH) || defined(USE_AIO_ATOMIC_BUILTIN_COMP_SWAP)
+        char *envvarpointer = (char *)0;  /*  might point to an environment variable string */
+        char *charptr;
+#endif /* USE_PREFETCH */
+
+#ifdef USE_AIO_SIGEVENT                                    /*    signal waiters instead of letting them poll */
+/*    signal environment to invoke BufHandlSigAsync    */
+struct sigaction chsigaction , olsigAIOaction;
+#endif /*  USE_AIO_SIGEVENT    */
 
 	BufferDescriptors = (BufferDesc *)
 		ShmemInitStruct("Buffer Descriptors",
@@ -83,6 +203,146 @@ InitBufferPool(void)
 		ShmemInitStruct("Buffer Blocks",
 						NBuffers * (Size) BLCKSZ, &foundBufs);
 
+
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+        BAiocbAnchr = (struct BAiocbAnchor *)0; /*  anchor for all control blocks pertaining to aio  */
+        if (max_async_io_prefetchers < 0) {  /*  negative value indicates to initialize to something sensible during buf_init */
+            max_async_io_prefetchers = MaxConnections/6;  /*  default allows for average of MaxConnections/6 concurrent prefetchers  - reasonable ??? */
+        }
+
+        if ((target_prefetch_pages > 0) && (max_async_io_prefetchers > 0)) {
+            int ix;
+            volatile struct BufferAiocb *BufferAiocbs;
+            volatile struct BufferAiocb * volatile FreeBAiocbs;
+
+            numBufferAiocbs = (target_prefetch_pages*max_async_io_prefetchers);  /*  target_prefetch_pages per prefetcher */
+            BAiocbAnchr = (struct BAiocbAnchor *)
+	        	ShmemInitStruct("Buffer Aiocbs",
+                          sizeof(struct BAiocbAnchor) + (numBufferAiocbs * sizeof(struct BufferAiocb)), &foundAiocbs);
+            if (BAiocbAnchr) {
+                BufferAiocbs = BAiocbAnchr->BufferAiocbs = (struct BufferAiocb*)(((char *)BAiocbAnchr) + sizeof(struct BAiocbAnchor));
+                FreeBAiocbs = (struct BufferAiocb*)0;
+                for (ix = (numBufferAiocbs-1);  ix>=0;  ix--) {
+                    (BufferAiocbs+ix)->BAiocbnext = FreeBAiocbs;   /*  init the free list,  last one -> 0  */
+                    (BufferAiocbs+ix)->BAiocbbufh = (struct sbufdesc*)0;
+                    (BufferAiocbs+ix)->BAiocbDependentCount = 0;
+                    (BufferAiocbs+ix)->pidOfAio = 0;
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on signal instead of polling */
+			        (BufferAiocbs+ix)->BAiocbWaiterchain = (struct PGPROC *)0; /* initially not on a chain */
+#endif /*  USE_AIO_SIGEVENT    */
+                    FreeBAiocbs = (BufferAiocbs+ix);
+
+                }
+                BAiocbAnchr->FreeBAiocbs = FreeBAiocbs;
+                envvarpointer = getenv("PG_MAX_GET_BAIOCB_TRIES");
+                if (    (envvarpointer != (char *)0)
+                     && (   ('1' <= *envvarpointer) && ('9' >= *envvarpointer)   )
+                   ) {
+                      maxGetBAiocbTries = strtol(envvarpointer, 0, 10);
+                }
+                envvarpointer = getenv("PG_MAX_REL_BAIOCB_TRIES");
+                if (    (envvarpointer != (char *)0)
+                     && (   ('1' <= *envvarpointer) && ('9' >= *envvarpointer)   )
+                   ) {
+                      maxRelBAiocbTries = strtol(envvarpointer, 0, 10);
+                }
+
+#ifdef USE_AIO_SIGEVENT                                    /*    signal waiters instead of letting them poll */
+				/*    set our signal environment to invoke BufHandlSigAsync    */
+				sigfillset(&blockaiosighandlrmask);
+				chsigaction.sa_sigaction = (void(*)(int, siginfo_t *, void *ucontext))&BufHandlSigAsync; /*  call for siginfo */
+				chsigaction.sa_mask = blockaiosighandlrmask;
+				chsigaction.sa_flags = SA_SIGINFO; /*  call for siginfo */
+				sigaction(AIO_SIGEVENT_SIGNALNUM, &chsigaction, &olsigAIOaction);
+#endif /*  USE_AIO_SIGEVENT    */
+            }
+        }
+#else   /*  not USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+        /*   this dummy structure is to ensure that references to these fields in other bufmgr runtime code
+        **   that is not conditionally ifdefd on USE_AIO_ATOMIC_BUILTIN_COMP_SWAP compiles and runs correctly
+        */
+        BAiocbAnchr = &dummy_BAiocbAnchr;
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+
+
+#ifdef USE_PREFETCH
+        envvarpointer = getenv("PG_TRY_PREFETCHING_FOR_BITMAP");
+        if (envvarpointer != (char *)0) {
+             if (    ('N' == *envvarpointer) || ('n' == *envvarpointer)   ) {
+                 prefetch_bitmap_scans = 0;
+             } else
+             if (    ('Y' == *envvarpointer) || ('y' == *envvarpointer)   ) {
+                 prefetch_bitmap_scans = 1;
+             }
+        }
+        envvarpointer = getenv("PG_TRY_PREFETCHING_FOR_ISCAN");
+        if (envvarpointer != (char *)0) {
+             if (    ('N' == *envvarpointer) || ('n' == *envvarpointer)   ) {
+                 prefetch_index_scans = 0;
+             } else
+             if (    ('Y' == *envvarpointer) || ('y' == *envvarpointer)   ) {
+                 prefetch_index_scans = 1;
+             } else
+             if (   ('1' <= *envvarpointer) && ('9' >= *envvarpointer)   ) {
+                 prefetch_index_scans = strtol(envvarpointer, &charptr, 10);
+                 if (charptr && (',' == *charptr)) {   /*  optional sequential prefetch in index scans */
+					 charptr++;        /*   following the comma ... */
+					 if ( ('Y' == *charptr) || ('y' == *charptr) || ('1' == *charptr) ) {
+                         prefetch_sequential_index_scans = 1;
+					 }
+				 }
+             }
+             /*  if prefeching for ISCAN,  then we require size of pfch_list to be at least target_prefetch_pages */
+             if (   (prefetch_index_scans > 0)
+                 && (prefetch_index_scans < target_prefetch_pages)
+                ) {
+                 prefetch_index_scans = target_prefetch_pages;
+             }
+        }
+        envvarpointer = getenv("PG_TRY_PREFETCHING_FOR_BTREE");
+        if (envvarpointer != (char *)0) {
+             if (    ('N' == *envvarpointer) || ('n' == *envvarpointer)   ) {
+                 prefetch_btree_heaps = 0;
+             } else
+             if (    ('Y' == *envvarpointer) || ('y' == *envvarpointer)   ) {
+                 prefetch_btree_heaps = 1;
+             }
+        }
+        envvarpointer = getenv("PG_TRY_PREFETCHING_FOR_HEAP");
+        if (envvarpointer != (char *)0) {
+             if (    ('N' == *envvarpointer) || ('n' == *envvarpointer)   ) {
+                 prefetch_heap_scans = 0;
+             } else
+             if (    ('Y' == *envvarpointer) || ('y' == *envvarpointer)   ) {
+              prefetch_heap_scans = 1;
+             }
+        }
+        envvarpointer = getenv("PG_PREFETCH_DBOID");
+        if (    (envvarpointer != (char *)0)
+             && (   ('1' <= *envvarpointer) && ('9' >= *envvarpointer)   )
+           ) {
+              errno = 0;   /*  required in order to distinguish error from 0 */
+              prefetch_dbOid = (unsigned int)strtoul((const char *)envvarpointer, 0, 10);
+              if (errno) {
+                  prefetch_dbOid = 0;
+              }
+        }
+        elog(LOG, "prefetching initialised with target_prefetch_pages= %d "
+                  ", max_async_io_prefetchers= %d implying aio concurrency= %d "
+                  ", prefetching_for_bitmap= %s "
+                  ", prefetching_for_heap= %s "
+                  ", prefetching_for_iscan= %d with sequential_index_page_prefetching= %s "
+                  ", prefetching_for_btree= %s"
+                   ,target_prefetch_pages ,max_async_io_prefetchers ,numBufferAiocbs
+                   ,(prefetch_bitmap_scans ? "Y" : "N")
+                   ,(prefetch_heap_scans ? "Y" : "N")
+                   ,prefetch_index_scans
+                   ,(prefetch_sequential_index_scans ? "Y" : "N")
+                   ,(prefetch_btree_heaps ? "Y" : "N")
+            );
+#endif /* USE_PREFETCH */
+
+
 	if (foundDescs || foundBufs)
 	{
 		/* both should be present or neither */
@@ -176,3 +436,82 @@ BufferShmemSize(void)
 
 	return size;
 }
+
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+/*     imprecise count of number of in-use BAiocbs at any time
+ *     we scan the array read-only without latching so are subject to unstable result
+ *     (but since the array is in well-known contiguous storage,
+ *     we are not subject to segmentation violation)
+ *     This function may be called at any time and just does its best
+ *     return the count of what we counted.
+ */
+int
+CountInuseBAiocbs(void)
+{
+        volatile struct BufferAiocb *BAiocb;
+        int count = 0;
+        int ix;
+
+
+        if (BAiocbAnchr != (struct BAiocbAnchor *)0 ) {
+            BAiocb = BAiocbAnchr->BufferAiocbs;             /*   start of list */
+
+            for (ix = (numBufferAiocbs-1);  ix>=0;  ix--) {
+                    if ((struct BufferAiocb*)BAIOCB_OCCUPIED == (BAiocb+ix)->BAiocbnext) {   /* not on freelist ? */
+                        count++;
+                    }
+            }
+        }
+        return count;
+}
+
+/*
+ * report how many free BAiocbs at shutdown
+ * DO NOT call this while backends are actively working!!
+ * this report is useful when compare_and_swap method used (see above)
+ * as it can be used to deduce how many BAiocbs were in process-local caches -
+ * (original_number_on_freelist_at_startup - this_reported_number_at_shutdown)
+ */
+void
+ReportFreeBAiocbs(void)
+{
+        volatile struct BufferAiocb *BAiocb;
+        volatile struct BufferAiocb *BufferAiocbs;
+        int count = 0;
+        int fx , ix;
+
+
+        if (BAiocbAnchr != (struct BAiocbAnchor *)0 ) {
+            BAiocb = BAiocbAnchr->FreeBAiocbs;             /*   start of free list */
+            BufferAiocbs = BAiocbAnchr->BufferAiocbs;
+
+            for (ix = (numBufferAiocbs-1);  ix>=0;  ix--) {
+                    (BufferAiocbs+ix)->BAiocbDependentCount = 0;  /* use this as marker for finding it on freelist */
+            }
+            for (fx = (numBufferAiocbs-1);  ( (fx>=0) &&  ( BAiocb != (struct BufferAiocb*)0 ) );  fx--) {
+                    
+                    /*  check if it is a valid BufferAiocb */
+                    for (ix = (numBufferAiocbs-1);  ix>=0;  ix--) {
+                        if ((BufferAiocbs+ix) == BAiocb) { /*  is it this one ? */
+                             break;
+                        }
+                    }
+                    if (ix >= 0) {
+                        if (BAiocb->BAiocbDependentCount) {   /* seen it already ? */
+                            elog(LOG, "ReportFreeBAiocbs closed cycle on AIO control block freelist %p"
+                                          ,BAiocb);
+                            fx = 0; /* give up at this point */
+                        }
+                        BAiocb->BAiocbDependentCount = 1;  /* use this as marker for finding it on freelist */
+                        count++;
+                        BAiocb = BAiocb->BAiocbnext;
+                    } else {
+                        elog(LOG, "ReportFreeBAiocbs invalid item on AIO control block freelist %p"
+                                          ,BAiocb);
+                        fx = 0; /* give up at this point */
+                    }
+            }
+        }
+        elog(LOG, "ReportFreeBAiocbs AIO control block list : poolsize= %d  in-use-hwm= %d  final-free= %d" ,numBufferAiocbs , hwmBufferAiocbs , count);
+}
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
--- src/backend/storage/smgr/md.c.orig	2014-08-18 14:10:36.941017108 -0400
+++ src/backend/storage/smgr/md.c	2014-08-19 16:56:13.603196872 -0400
@@ -664,6 +664,80 @@ mdprefetch(SMgrRelation reln, ForkNumber
 }
 
 
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+/*
+ *	mdinitaio() --  init the aio subsystem max number of threads and max number of requests
+ */
+void
+mdinitaio(int max_aio_threads, int max_aio_num)
+{
+     FileInitaio( max_aio_threads, max_aio_num );
+}
+
+/*
+ *	mdstartaio() -- start aio read of the specified block of a relation
+ */
+void
+mdstartaio(SMgrRelation reln, ForkNumber forknum, BlockNumber blocknum , char *aiocbp , int *retcode
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , unsigned long BAiocbaioOrdinal
+#endif /*  USE_AIO_SIGEVENT    */
+ )
+{
+#ifdef USE_PREFETCH
+	off_t		seekpos;
+	MdfdVec    *v;
+        int local_retcode;
+
+	v = _mdfd_getseg(reln, forknum, blocknum, false, EXTENSION_FAIL);
+
+	seekpos = (off_t) BLCKSZ *(blocknum % ((BlockNumber) RELSEG_SIZE));
+
+	Assert(seekpos < (off_t) BLCKSZ * RELSEG_SIZE);
+
+	local_retcode = FileStartaio(v->mdfd_vfd, seekpos, BLCKSZ , aiocbp
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , BAiocbaioOrdinal
+#endif /*  USE_AIO_SIGEVENT    */
+                                   );
+	if (retcode) {
+            *retcode = local_retcode;
+        }
+#endif   /* USE_PREFETCH */
+}
+
+
+/*
+ *	mdcompleteaio() -- complete aio read of the specified block of a relation
+ *      on entry, *inoutcode should indicate :
+ *           .  non-0  <=>   check if complete and wait if not
+ *           .  0      <=>   cancel io immediately
+ */
+void
+mdcompleteaio( char *aiocbp , int *inoutcode
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , int (*BufAWaitAioCompletion)(char *)  /*  function to await completion if non-originator */
+                                , char *BAiocbP /* pointer to BAIOcb  */
+#endif /*  USE_AIO_SIGEVENT    */
+             )
+{
+#ifdef USE_PREFETCH
+        int local_retcode;
+
+	local_retcode = FileCompleteaio(aiocbp, (inoutcode ? *inoutcode : 0)
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , BufAWaitAioCompletion
+                                , BAiocbP /* pointer to BAIOcb  */
+#endif /*  USE_AIO_SIGEVENT    */
+                                       );
+	if (inoutcode) {
+            *inoutcode = local_retcode;
+        }
+#endif   /* USE_PREFETCH */
+}
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+
+
 /*
  *	mdread() -- Read the specified block from a relation.
  */
--- src/backend/storage/smgr/smgr.c.orig	2014-08-18 14:10:36.941017108 -0400
+++ src/backend/storage/smgr/smgr.c	2014-08-19 16:56:13.623196943 -0400
@@ -49,6 +49,21 @@ typedef struct f_smgr
 						 BlockNumber blocknum, char *buffer, bool skipFsync);
 	void		(*smgr_prefetch) (SMgrRelation reln, ForkNumber forknum,
 											  BlockNumber blocknum);
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+	void		(*smgr_initaio) (int max_aio_threads, int max_aio_num);
+	void		(*smgr_startaio) (SMgrRelation reln, ForkNumber forknum,
+											  BlockNumber blocknum , char *aiocbp , int *retcode
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , unsigned long BAiocbaioOrdinal
+#endif /*  USE_AIO_SIGEVENT    */
+                                 );
+	void		(*smgr_completeaio) ( char *aiocbp , int *inoutcode
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , int (*BufAWaitAioCompletion)(char *)  /*  function to await completion if non-originator */
+                                , char *BAiocbP /* pointer to BAIOcb  */
+#endif /*  USE_AIO_SIGEVENT    */
+                                    );
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
 	void		(*smgr_read) (SMgrRelation reln, ForkNumber forknum,
 										  BlockNumber blocknum, char *buffer);
 	void		(*smgr_write) (SMgrRelation reln, ForkNumber forknum,
@@ -66,7 +81,11 @@ typedef struct f_smgr
 static const f_smgr smgrsw[] = {
 	/* magnetic disk */
 	{mdinit, NULL, mdclose, mdcreate, mdexists, mdunlink, mdextend,
-		mdprefetch, mdread, mdwrite, mdnblocks, mdtruncate, mdimmedsync,
+		mdprefetch
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+                        ,mdinitaio, mdstartaio, mdcompleteaio
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+              , mdread, mdwrite, mdnblocks, mdtruncate, mdimmedsync,
 		mdpreckpt, mdsync, mdpostckpt
 	}
 };
@@ -612,6 +631,53 @@ smgrprefetch(SMgrRelation reln, ForkNumb
 	(*(smgrsw[reln->smgr_which].smgr_prefetch)) (reln, forknum, blocknum);
 }
 
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+/*
+ *	smgrinitaio() -- initialize the aio subsystem max number of threads and max number of requests
+ */
+void
+smgrinitaio(int max_aio_threads, int max_aio_num)
+{
+	(*(smgrsw[0].smgr_initaio)) ( max_aio_threads, max_aio_num );
+}
+
+/*
+ *	smgrstartaio() -- Initiate aio read of the specified block of a relation.
+ */
+void
+smgrstartaio(SMgrRelation reln, ForkNumber forknum, BlockNumber blocknum , char *aiocbp , int *retcode
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , unsigned long BAiocbaioOrdinal
+#endif /*  USE_AIO_SIGEVENT    */
+             )
+{
+	(*(smgrsw[reln->smgr_which].smgr_startaio)) (reln, forknum, blocknum , aiocbp , retcode
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , BAiocbaioOrdinal
+#endif /*  USE_AIO_SIGEVENT    */
+                                                );
+}
+
+/*
+ *	smgrcompleteaio() -- Complete aio read of the specified block of a relation.
+ */
+void
+smgrcompleteaio(SMgrRelation reln,  char *aiocbp , int *inoutcode
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , int (*BufAWaitAioCompletion)(char *)  /*  function to await completion if non-originator */
+                                , char *BAiocbP /* pointer to BAIOcb  */
+#endif /*  USE_AIO_SIGEVENT    */
+               )
+{
+	(*(smgrsw[reln->smgr_which].smgr_completeaio)) ( aiocbp , inoutcode
+#ifdef USE_AIO_SIGEVENT     /*    non-originator waiters wait on lock instead of polling */
+                                , BufAWaitAioCompletion
+                                , BAiocbP
+#endif /*  USE_AIO_SIGEVENT    */
+                                                   );
+}
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+
 /*
  *	smgrread() -- read a particular block from a relation into the supplied
  *				  buffer.
